/* Sistemas Integrados TECNISA

Nome: 0212_GERTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   26/02/2004 - Jenilson
*/


/* Tabela LISTAINFLAC: Lista Inflacionria*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela LISTAINFLAC*/
/* Objetivo: Gerar log de alteraes realizadas na tabela Lista Inflacionria,
             utilizando a tabela Geral de Logs de Operaes*/
CREATE OR REPLACE TRIGGER LOG_SUP_LISTAINFLAC
AFTER DELETE OR INSERT OR UPDATE
ON LISTAINFLAC FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC       := 'Filial '        || '' || :NEW.CDFILCENTCMP  || ' ' ||
                      'Lista '         || '' || :NEW.NRLISTINFLAC  || ' ' ||
                      'Nome '          || '' || :NEW.NMLISTINFLAC  || ' ' ||
                      'Dt Referencia ' || '' || :NEW.DTREFLISTINF  || ' ' ||
                      'Dt Inicial '    || '' || :NEW.DTINILISTINF  || ' ' ||
                      'Dt Final '      || '' || :NEW.DTFINLISTINF  || ' ' ||
                      'Operador '      || '' || :NEW.CDOPERADOR    || ' ' ||
                      'Dt Geracao '    || '' || :NEW.DTGERLISTINF  || ' ' ||
                      'Identificador ' || '' || :NEW.IDLISINFATIV;
      V_ITPESQ       := :NEW.CDFILCENTCMP||:NEW.NRLISTINFLAC;
      V_CDFILLOGOPER := :NEW.CDFILCENTCMP;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC       := 'Filial '        || '' || :NEW.CDFILCENTCMP  || ' ' ||
                         'Lista '         || '' || :NEW.NRLISTINFLAC  || ' ' ||
                         'Nome '          || '' || :NEW.NMLISTINFLAC  || ' ' ||
                         'Dt Referencia ' || '' || :NEW.DTREFLISTINF  || ' ' ||
                         'Dt Inicial '    || '' || :NEW.DTINILISTINF  || ' ' ||
                         'Dt Final '      || '' || :NEW.DTFINLISTINF  || ' ' ||
                         'Operador '      || '' || :NEW.CDOPERADOR    || ' ' ||
                         'Dt Geracao '    || '' || :NEW.DTGERLISTINF  || ' ' ||
                         'Identificador ' || '' || :NEW.IDLISINFATIV;
         V_ITPESQ       := :NEW.CDFILCENTCMP||:NEW.NRLISTINFLAC;
         V_CDFILLOGOPER := :NEW.CDFILCENTCMP;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING  THEN
            V_DESC       := 'Filial '        || '' || :OLD.CDFILCENTCMP  || ' ' ||
                            'Lista '         || '' || :OLD.NRLISTINFLAC  || ' ' ||
                            'Nome '          || '' || :OLD.NMLISTINFLAC  || ' ' ||
                            'Dt Referencia ' || '' || :OLD.DTREFLISTINF  || ' ' ||
                            'Dt Inicial '    || '' || :OLD.DTINILISTINF  || ' ' ||
                            'Dt Final '      || '' || :OLD.DTFINLISTINF  || ' ' ||
                            'Operador '      || '' || :OLD.CDOPERADOR    || ' ' ||
                            'Dt Geracao '    || '' || :OLD.DTGERLISTINF  || ' ' ||
                            'Identificador ' || '' || :OLD.IDLISINFATIV;
            V_ITPESQ       := :OLD.CDFILCENTCMP||:OLD.NRLISTINFLAC;
            V_CDFILLOGOPER := :OLD.CDFILCENTCMP;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER,
       CDFILLOGOPER)
    VALUES
      ('LISTAINFLAC',
       SYSDATE,
       NVL(V_NMOPERADOR, ' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       V_CDFILLOGOPER);
END;
/

