<?php
namespace Zeedhi\Framework\Annotations\Definitions;

/**
 * @Annotation
 * @Target("ANNOTATION")
 */
final class Schema {
    /** @var string */
    public $title;

    /** @var string */
    public $pattern;

    /** @var boolean */
    public $required;

    /** @var array */
    public $enum;

    /** @var float */
    public $minimum;

    /** @var float */
    public $maximum;

    /** @var boolean */
    public $exclusiveMinimum;

    /** @var boolean */
    public $exclusiveMaximum;

    /** @var float */
    public $multipleOf;

    /** @var integer */
    public $minLength;

    /** @var integer */
    public $maxLength;

    /** @var integer */
    public $minItems;

    /** @var integer */
    public $maxItems;

    /** @var boolean */
    public $uniqueItems;

    /** @var integer */
    public $minProperties;

    /** @var integer */
    public $maxProperties;

    /** @var mixed */
    public $discriminator;

    /** @var mixed */
    public $xml;

    /** @var string */
    public $type;

    /** @var boolean */
    public $nullable;

    /** @var string */
    public $description;

    /** @var mixed */
    public $default;

    /** @var mixed */
    public $format;

    /** @var mixed */
    public $properties;

    /** @var mixed */
    public $allOf;

    /** @var mixed */
    public $oneOf;

    /** @var mixed */
    public $items;

    /** @var mixed */
    public $anyOf;

    /** @var mixed */
    public $not;

    /** @var mixed */
    public $additionalProperties;

    /** @var boolean */
    public $writeOnly;

    /** @var boolean */
    public $readOnly;

    /** @var boolean */
    public $deprecated;

    /** @var mixed */
    public $example;
}